///////////////////////////
//
// Main.cpp
//
// This is a program that I intend to enahance later on
// Right now I was searching for a suitable way to convert
// different sorts of simple files into HTML
// 
// None of the prorams that I have worked with generate a neat
// and clean HTML file
//
// My attempt here would be to use the latest XHTML + CSS
// to generate HTML files
//
// Initially I intend to do just CPP and plain text files
// but later my intention is to also do rich text format
//
// Although it would be ideal to be able to read in the formatting
// from an XML file and then be able to convert it
// However to begin with I will design hard coded structures
// and then perhaps later on I will switch using XML 
// to specify the file style
//
////////////////////////////////////




#include "StdAfx.h"

#include "ParserCPP.h"



bool isCorrectFileType (const char* file)
{
	string fileName (file);
	int len = fileName.length();
	string ext_cpp = fileName.substr (len-3, 3);
	string ext_h = fileName.substr (len-1, 1);

	if (ext_cpp == string ("cpp") || ext_h == string ("h"))
		return (true);
	else
		return (false);
}


void writeHTMLPrologue (std::ofstream& outFile)
{
	std::ifstream header ("Header.html");
	if (header.is_open())
	{
		outFile << header.rdbuf(); 
	}
	else
	{
		std::runtime_error err ("Header.html file is missing.");
		throw (err);
	}

	// typially read the prologue from the prologue file and spit it out here
	//outFile << "<html>\n";
	//outFile << "\t<body>\n";
	
}


void writeHTMLEpilogue(std::ofstream& outFile)
{
	std::ifstream footer ("Footer.html");
	if (footer.is_open())
	{
		outFile << footer.rdbuf(); 
	}
	else
	{
		std::runtime_error err ("Footer.html file is missing.");
		throw (err);
	}


	// typially read the eplilogue from the epilogue file and spit it out here
	//outFile << "\t</body>\n";
	//outFile << "<html>\n";
}



void parseCPP (std::ifstream& inFile, std::ofstream& outFile)
{
	ParserCPP cpp (inFile, outFile);
	cpp.parse();
}






// -------------------------------------------------
void main(int argc, char* argv[])
{
	
	if (argc == 1)
	{
		cout << "Usage: cpp2html sourcefile [targetfile]\n";
		return;
	}

	// otherwise there must have been more arguments 
	if (!isCorrectFileType(argv[1]))
	{
		cout << "File type not supported.\n";
		return;
	}
	

	// otherwise create the input and output files
	std::ifstream inFile (argv[1]);
	//std::ifstream inFile ("test.cpp");			// --- for testing

	std::ofstream outFile;
	if (argc > 2)
		outFile.open (argv[2]);
	else
	{
		std::string outFileName = std::string (argv[1]) + std::string (".html");
		//std::string outFileName = std::string ("test.cpp.html");		// --- for testing
		outFile.open (outFileName.c_str());
	}

	
	
	try
	{
		// now do the work
		writeHTMLPrologue (outFile);
		parseCPP (inFile, outFile);
		writeHTMLEpilogue(outFile);
	}

	catch (std::runtime_error& err)
	{
		cout << err.what();
	}
}






	


